
jQuery(document).ready(function() {

    var sqPaymentForm;

    jQuery(document).on('submit','#buycred-checkout-form',function(evv){
        if (jQuery( "input[name*='mycred_buy']" ).val() === 'mycred_square'  || jQuery( "select[name*='mycred_buy']" ).val() === 'mycred_square'  ) {
            evv.preventDefault();
            sqPaymentForm.requestCardNonce();
            jQuery("#sq-creditcard").text('Please Wait...');
            return false;
        }

    });

    jQuery("#sq-creditcard").on('click',function(evv){


        evv.preventDefault();
        sqPaymentForm.requestCardNonce();
        jQuery("#sq-creditcard").text('Please Wait...');
        return false;


    });
    function buildsquarefields(myAjax){

        if(myAjax.application_id) {
            sqPaymentForm = new SqPaymentForm({

                applicationId: myAjax.application_id,
                locationId: myAjax.location_id,

                inputClass: 'sq-input',
                cardNumber: {
                    elementId: 'sq-card-number',
                    placeholder: "•••• •••• •••• ••••"
                },
                cvv: {
                    elementId: 'sq-cvv',
                    placeholder: 'CVV'
                },
                expirationDate: {
                    elementId: 'sq-expiration-date',
                    placeholder: 'MM/YY'
                },
                postalCode: {
                    elementId: 'sq-postal-code',
                    placeholder: 'Postal Code'
                },
                inputStyles: [

                    // Because this object provides no value for mediaMaxWidth or mediaMinWidth,
                    // these styles apply for screens of all sizes, unless overridden by another
                    // input style below.
                    {
                        fontSize: '14px',
                        padding: '3px',

                    },

                    // These styles are applied to inputs ONLY when the screen width is 400px
                    // or smaller. Note that because it doesn't specify a value for padding,
                    // the padding value in the previous object is preserved.
                    {
                        mediaMaxWidth: '400px',
                        fontSize: '18px',
                    }
                ],
                callbacks: {
                    cardNonceResponseReceived: function (errors, nonce, cardData) {
                        var nonceField = document.getElementById('card-nonce');
                        var amount = jQuery('#amount').val();
                        nonceField.value = nonce;
                        var amount01 = amount.toString();
                        amount = amount.toString();
                        var currency = myAjax.currency;
                        var points = myAjax.points_amount;
                        var final_points = amount;
                        amount = (amount01 * points).toString();

                        //console.log(currency);
                        const verificationDetails = {
                            intent: 'CHARGE',
                            amount: amount,
                            currencyCode: currency,
                            billingContact: {}
                        };


                        if (errors) {
                            var html = '';

                            html += '<ul class="_error error">';

                            // handle errors
                            jQuery(errors).each(function (index, error) {
                                html += '<li>' + error.message + '</li>';
                            });

                            html += '</ul>';

                            // append it to DOM
                            jQuery('#sq-ccbox #error').eq(0).html(html);
                            jQuery("#sq-creditcard").text('Payment');
                            var errorDiv = document.getElementById('errors');

                        } else {


                            sqPaymentForm.verifyBuyer(
                                nonce,
                                verificationDetails,
                                function (err, verificationResult) {
                                    //console.log(verificationResult.token);
                                    if (err == null) {
                                        //TODO: Move existing Fetch API call here
                                        jQuery.noConflict();
                                        jQuery.ajax({
                                            type: "post",
                                            url: myAjax.ajaxurl,
                                            data: {
                                                action: "mcs_payment_process",
                                                cardData: cardData,
                                                nonce: nonce,
                                                amount: amount,
                                                buyerVerification_token: verificationResult.token,
                                                currency: currency,
                                                points: final_points,

                                            },

                                            success: function (response) {
                                                console.log(response);
                                                if (response == "Purchase completed") {

                                                    jQuery("#nonce-form").hide();
                                                    jQuery("#sq-ccbox").append("<center><h2>Thank You payment successfully paid </h2></center>");
                                                    /*          document.getElementById("nonce-form").reset();*/
                                                    if(myAjax.thankyou_page != 0 && myAjax.thankyou_page != null) {
                                                        window.location = myAjax.thankyou_page;

                                                    }
                                                } else {

                                                    jQuery("#nonce-form").hide();
                                                    jQuery("#sq-ccbox").append("<center><h2> Failed Try Again </h2></center>");

                                                    /*      document.getElementById("nonce-form").reset();*/
                                                }
                                            },
                                            error: function (response) {
                                               // console.log(response);
                                                console.log(response);
                                                jQuery("#nonce-form").hide();
                                                jQuery("#sq-ccbox").append("<center><h2> Failed Try Again </h2></center>");

                                            }
                                        });

                                    }

                                });
                        }

                    },
                    unsupportedBrowserDetected: function () {
                        // Alert the buyer that their browser is not supported
                    }
                }
            });
        }
           if (jQuery("#buycred-checkout-form")[0] == null){
               if( jQuery('#sq-card-number').length ){
                   if(myAjax.application_id ) {
                     //  if (myAjax.checkoutoption == 'popup') {
                           sqPaymentForm.build();
                      // } else {
                           //alert("buyCRED square work on popup check your buyCRED setting.");
                      // }
                   }
               }
        }
    }

        buildsquarefields(myAjax);



    jQuery( 'form.form.myCRED-buy-form' ).on( 'submit', function( event ) {
        if (jQuery( "input[name*='mycred_buy']" ).val() === 'mycred_square'  || jQuery( "select[name*='mycred_buy']" ).val() === 'mycred_square'  ) {
            event.preventDefault();
            jQuery.noConflict();
            if(jQuery( "input[name*='amount']" ).val() != null) {
                if (myAjax.checkoutoption == 'popup') {
                    buildsquarefields(myAjax);
                    setTimeout(function () {
                        if (myAjax.application_id) {
                            sqPaymentForm.build();
                        } else {
                            alert("Connect your Square account or submit sandbox credentials before using myCred Square.");
                        }
                    }, 1000);
               } else {
                   alert("buyCRED square work on popup check your buyCRED setting.");

               }
            }

        }

    });

    jQuery(document).on('click','.mycred_square_close_btn',function(e){
        e.preventDefault();
        if(myAjax.application_id) {
            sqPaymentForm.destroy();
            if(myAjax.cancel_page != 0 && myAjax.cancel_page != null  ) {
                window.location = myAjax.cancel_page;
            }
            }
    });

    if (jQuery("#buycred-checkout-form")[0] == null){
       // jQuery('.mycred_square_close_btn').hide();
    } else{
        jQuery('.mycred_square_close_btn').show();
    }


});

